/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.asynch;

import junit.framework.Test;
import junit.framework.TestSuite;
import org.jboss.aspects.asynch.AsynchProvider;
import org.jboss.aspects.asynch.Future;
import org.jboss.test.JBossTestCase;
import org.jboss.test.aop.test.AOPTestSetup;


/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1.8.3 $
 */
public class AsynchTestCase
extends JBossTestCase
{
   org.apache.log4j.Category log = getLog();

   static boolean deployed = false;
   static int test = 0;

   public AsynchTestCase(String name)
   {

      super(name);

   }

   public void testRemote() throws Exception
   {
      try
      {
         POJO pojo = (POJO) getInitialContext().lookup("pojo");

         AsynchProvider asynch = (AsynchProvider) pojo;
         pojo.testMethod(5);

         Future future = asynch.getFuture();
         int rtn = ((Integer) future.get()).intValue();
         assertEquals(rtn, 5);

         pojo.testMethod("hello");

         future = asynch.getFuture();
         String srtn = (String) future.get();
         assertEquals("hello", srtn);
      }
      catch (Exception e)
      {
         throw new RuntimeException(e);
      }

   }

   public void testLocal() throws Exception
   {
      POJO pojo = (POJO) getInitialContext().lookup("pojo");

      pojo.test();
   }

   public void testCollocated() throws Exception
   {
      POJO pojo = (POJO) getInitialContext().lookup("pojo");

      pojo.testCollocated();
   }

   public static Test suite() throws Exception
   {
      TestSuite suite = new TestSuite();
      suite.addTest(new TestSuite(AsynchTestCase.class));

      AOPTestSetup setup = new AOPTestSetup(suite, "asynch-test.sar");
      return setup;
   }

}
